# SoTransformBoxDragger Class Reference
[Draggers]

`#include <Inventor/draggers/SoTransformBoxDragger.h>`

Inheritance diagram for SoTransformBoxDragger:

List of all members.

## Detailed Description

The SoTransformBoxDragger provides a box which can be translated, scaled and rotated.

Here's how the dragger looks with it's default geometry in the inactive state:

Translate the dragger by clicking and dragging any of the (invisible) sides. Scaling is done by dragging the corner cubes. Only uniform scaling is supported. Rotation is done by dragging any of the 12 beams connecting the corner cubes.

This dragger consists of a rigid framework for doing all the usual interaction operations on scene geometry. The "user interface" of the dragger is very simple, providing little room for the end-user to make mistakes.

For the application programmer's convenience, the Coin library also provides a manipulator class called SoTransformBoxManip, which wraps the SoTransformBoxDragger into the necessary mechanisms for making direct insertion of this dragger into a scenegraph possible with very little effort.

See also:
  SoTransformBoxManip

## Public Member Functions

| SoTransformBoxDragger (void)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoSFRotation | rotation
SoSFVec3f | translation
SoSFVec3f | scaleFactor

## Protected Member Functions

| ~SoTransformBoxDragger ()
virtual SbBool | setUpConnections (SbBool onoff, SbBool doitalways=FALSE)
virtual void | setDefaultOnNonWritingFields (void)

## Static Protected Member Functions

void | invalidateSurroundScaleCB (void *f, SoDragger *d)
void | fieldSensorCB (void *f, SoSensor *s)
void | valueChangedCB (void *f, SoDragger *d)

## Protected Attributes

SoFieldSensor * | rotFieldSensor
SoFieldSensor * | translFieldSensor
SoFieldSensor * | scaleFieldSensor

## Constructor & Destructor Documentation

SoTransformBoxDragger::SoTransformBoxDragger | ( | void |  | ) |

Default constructor, sets up the dragger nodekit catalog with the interaction and feedback geometry.

Node kit structure (new entries versus parent class marked with arrow prefix):

      CLASS SoTransformBoxDragger
      -->"this"
            "callbackList"
            "topSeparator"
               "motionMatrix"
      -->      "surroundScale"
      -->      "antiSquish"
      -->      "scaler"
      -->      "rotator1Sep"
      -->         "rotator1Rot"
      -->         "rotator1"
      -->      "rotator2Sep"
      -->         "rotator2Rot"
      -->         "rotator2"
      -->      "rotator3Sep"
      -->         "rotator3Rot"
      -->         "rotator3"
      -->      "translator1Sep"
      -->         "translator1Rot"
      -->         "translator1"
      -->      "translator2Sep"
      -->         "translator2Rot"
      -->         "translator2"
      -->      "translator3Sep"
      -->         "translator3Rot"
      -->         "translator3"
      -->      "translator4Sep"
      -->         "translator4Rot"
      -->         "translator4"
      -->      "translator5Sep"
      -->         "translator5Rot"
      -->         "translator5"
      -->      "translator6Sep"
      -->         "translator6Rot"
      -->         "translator6"
               "geomSeparator"

(See SoBaseKit::printDiagram() for information about the output formatting.)

Detailed information on catalog parts:

      CLASS SoTransformBoxDragger
      PVT   "this",  SoTransformBoxDragger  ---
            "callbackList",  SoNodeKitListPart [ SoCallback, SoEventCallback ]
      PVT   "topSeparator",  SoSeparator  ---
      PVT   "motionMatrix",  SoMatrixTransform  ---
            "surroundScale",  SoSurroundScale  ---
            "antiSquish",  SoAntiSquish  ---
            "scaler",  SoScaleUniformDragger  ---
      PVT   "rotator1Sep",  SoSeparator  ---
      PVT   "rotator1Rot",  SoRotation  ---
            "rotator1",  SoRotateCylindricalDragger  ---
      PVT   "rotator2Sep",  SoSeparator  ---
      PVT   "rotator2Rot",  SoRotation  ---
            "rotator2",  SoRotateCylindricalDragger  ---
      PVT   "rotator3Sep",  SoSeparator  ---
      PVT   "rotator3Rot",  SoRotation  ---
            "rotator3",  SoRotateCylindricalDragger  ---
      PVT   "translator1Sep",  SoSeparator  ---
      PVT   "translator1Rot",  SoRotation  ---
            "translator1",  SoTranslate2Dragger  ---
      PVT   "translator2Sep",  SoSeparator  ---
      PVT   "translator2Rot",  SoRotation  ---
            "translator2",  SoTranslate2Dragger  ---
      PVT   "translator3Sep",  SoSeparator  ---
      PVT   "translator3Rot",  SoRotation  ---
            "translator3",  SoTranslate2Dragger  ---
      PVT   "translator4Sep",  SoSeparator  ---
      PVT   "translator4Rot",  SoRotation  ---
            "translator4",  SoTranslate2Dragger  ---
      PVT   "translator5Sep",  SoSeparator  ---
      PVT   "translator5Rot",  SoRotation  ---
            "translator5",  SoTranslate2Dragger  ---
      PVT   "translator6Sep",  SoSeparator  ---
      PVT   "translator6Rot",  SoRotation  ---
            "translator6",  SoTranslate2Dragger  ---
      PVT   "geomSeparator",  SoSeparator  ---

(See SoBaseKit::printTable() for information about the output formatting.)

SoTransformBoxDragger::~SoTransformBoxDragger | ( |  | ) | `[protected]`

| Protected destructor. (Dragger classes are derived from SoBase, so they are reference counted and automatically destroyed when their reference count goes to 0.)

## Member Function Documentation

void SoTransformBoxDragger::initClass | ( | void |  | ) | `[static]`

| Initializes type system for this dragger class. Application programmers should usually not have to invoke this method, see documentation of SoInteraction::init(). Reimplemented from SoDragger.

SbBool SoTransformBoxDragger::setUpConnections | ( | SbBool | onoff,
|  | SbBool | doitalways = FALSE
| ) | `[protected, virtual]`

| Sets up all internal connections for instances of this class. (This method will usually not be of interest to the application programmer, unless you want to extend the library with new custom nodekits or dragger classes. If so, see the SoBaseKit class documentation.) Reimplemented from SoInteractionKit.

void SoTransformBoxDragger::setDefaultOnNonWritingFields | ( | void |  | ) | `[protected, virtual]`

(Be aware that this method is unlikely to be of interest to the application programmer who does not want to extend the library with new custom nodekits or draggers. If you indeed are writing extensions, see the information in the SoBaseKit class documentation.)

This is a virtual method, and the code in it should call SoField::setDefault() with argument `TRUE` on part fields that should not be written upon scenegraph export operations.

This is typically done when:

1. field value is `NULL` and part is `NULL` by default

2. it is a leaf SoGroup or SoSeparator node with no children

3. it is a leaf listpart with no children and an SoGroup or SoSeparator container

4. it is a non-leaf part and it's of SoGroup type and all fields are at their default values

Subclasses should usually override this to do additional settings for new member fields. From the subclass, do remember to call "upwards" to your superclass' setDefaultOnNonWritingFields() method.

Reimplemented from SoDragger.

void SoTransformBoxDragger::invalidateSurroundScaleCB | ( | void * | f,
|  | SoDragger * | d
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

void SoTransformBoxDragger::fieldSensorCB | ( | void * | d,
|  | SoSensor * | s
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Reimplemented from SoInteractionKit.

void SoTransformBoxDragger::valueChangedCB | ( | void * | f,
|  | SoDragger * | d
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## Member Data Documentation

SoSFRotation SoTransformBoxDragger::rotation

| This field is continuously updated to contain the rotation of the dragger's box.

SoSFVec3f SoTransformBoxDragger::translation

| The dragger's offset position from the local origo.

SoSFVec3f SoTransformBoxDragger::scaleFactor

| Continuously updated to contain the current vector of scaling along the X, Y and Z axes. The three components will always be equal, as this dragger only supports uniform scale operations.

SoFieldSensor * SoTransformBoxDragger::rotFieldSensor`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SoFieldSensor * SoTransformBoxDragger::translFieldSensor`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SoFieldSensor * SoTransformBoxDragger::scaleFieldSensor`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

The documentation for this class was generated from the following files:

- SoTransformBoxDragger.h
- SoTransformBoxDragger.cpp